import javax.swing.JPanel;
import javax.swing.JComponent;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.*;
import java.util.Vector;
import java.awt.Graphics;
import javax.swing.BorderFactory;

public class DFolderComponent extends JPanel implements AbstractComponent{

    // DEPTH keeps track of the depth to which cards have been added.
    int DEPTH = 30;
    int WIDTH = 15;

    // Vector to store the elements on this card.
    Vector cardVector = new Vector();

    // Text area for folder name
    javax.swing.JTextField folderName = new javax.swing.JTextField();
    public boolean selected = false;
    public boolean exists = false;
    public boolean internal = false;
    // Constructor
    public DFolderComponent(){
	exists = true;
	super.setSize(new java.awt.Dimension(400, 665));
        super.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.DEFAULT_CURSOR));
        //super.setLocation(p);
        super.setVisible(true);
        super.setLayout(null);
        super.setBackground(java.awt.Color.lightGray);

	super.setToolTipText("Folder area for arranging cards.");

        // event handling for the card component
        super.addMouseListener(new java.awt.event.MouseAdapter() {
                public void mouseClicked(java.awt.event.MouseEvent e) {
                    folderComponentMouseClicked(e);
                }
            });


        folderName.setToolTipText("Folder name");
        folderName.setVisible(true);
        folderName.setSize(new java.awt.Dimension(60, 20));
        folderName.setSelectedTextColor(java.awt.SystemColor.textHighlight);
        folderName.setColumns(80);
        folderName.setBackground(java.awt.Color.lightGray);
        folderName.setLocation(new java.awt.Point(5, 3));
	folderName.setText("xml");
	super.add(folderName);

    }


    public Vector getComponentVector(){
	//System.out.println("Extracting the cardvector from folder" + folderName.getText());
	return cardVector;
    }

    // this is necessary for extending pattern to rule
    public void addCardVector(Vector tempVector){
	//cardVector = tempVect;
	Dimension d;
	for(int i=0; i < tempVector.size(); i++){
	    //System.out.println("Cycling through cardVector elements");
	    //d = ((AbstractComponent) cardVector.get(i)).getSize();
	    //((AbstractComponent) cardVector.get(i)).setLocation((this.getWidth() - (new Double(d.getWidth())).intValue())/2, DEPTH);
	    //DEPTH = DEPTH + 5 + (new Double(d.getHeight())).intValue();
	    internal = true;
	    add((AbstractComponent) tempVector.get(i));

	}
	    
    }


    public void add(AbstractComponent a){
	// *** ensure that only cards get added to folders
	//System.out.println("adding to folder:" + folderName.getText());
	if (a instanceof DCardComponent){
	    //System.out.println("Adding card to folder -> " + selected + "," + internal);
	    for (int i = 0 ; i < cardVector.size(); i++){
		((AbstractComponent)cardVector.get(i)).add(new DCardComponent());
	    }
	    if (selected == true || internal == true){
		Dimension d = ((AbstractComponent) a).getSize();
		// For top-down arrangement
		//a.setLocation(new Point((this.getWidth() - (new Double(d.getWidth())).intValue())/2, DEPTH));
		// For diagonal arrangement.
		if (this.getWidth() < WIDTH + (new Double(d.getWidth())).intValue()) WIDTH = 15;
		a.setLocation(new Point(WIDTH,DEPTH));	
		WIDTH = WIDTH + 5 + (new Double(d.getWidth())).intValue();	
		DEPTH = DEPTH - 10 + (new Double(d.getHeight())).intValue();
		if (this.getHeight() < DEPTH) {
		    super.setSize(new Dimension(this.getWidth(),DEPTH + 10));
		}
		cardVector.add((DCardComponent) a);
		super.add((DCardComponent) a);
		repaint();
		internal = false;
	    }
	} else {
	    //System.out.println("Adding something else to folder");
	    for (int i = 0 ; i < cardVector.size(); i++){
		((AbstractComponent)cardVector.get(i)).add(new DElementComponent());
	    }
	}
	//this.rearrange();
	   
    }

    public void moved(AbstractComponent card){
	// this method is to rearrange cards after one has been moved
	//System.out.println("Index of moved card = " + cardVector.indexOf(card));
	int i = cardVector.indexOf(card);
	Dimension d = ((AbstractComponent) cardVector.get(i)).getSize();
	int maxwidth = (new Double(this.getSize().getWidth())).intValue();
	int maxheight = (new Double(this.getSize().getHeight())).intValue();
	int width = (new Double(d.getWidth())).intValue();
	int height = (new Double(d.getHeight())).intValue();
	if (width + ((JComponent) cardVector.get(i)).getX() > maxwidth) {
	    ((AbstractComponent) cardVector.get(i)).setLocation(new Point(maxwidth - width,((JComponent) cardVector.get(i)).getY() ));
	} else if (((JComponent) cardVector.get(i)).getX() < 0) {
	    ((AbstractComponent) cardVector.get(i)).setLocation(new Point(5, ((JComponent) cardVector.get(i)).getY()));
	}
	if (height + ((JComponent) cardVector.get(i)).getY() > maxheight) {
	    ((AbstractComponent) cardVector.get(i)).setLocation(new Point(((JComponent) cardVector.get(i)).getX(), maxheight - height));
	} else if (((JComponent) cardVector.get(i)).getY() < 0) {
	    ((AbstractComponent) cardVector.get(i)).setLocation(new Point(((JComponent) cardVector.get(i)).getX(),5));
	}
	cardVector.insertElementAt(cardVector.remove(cardVector.indexOf(card)),0);

	// Now we need to redraw the cardVector
	super.removeAll();
	super.add(folderName);
	for (int j = 0; j < cardVector.size(); j++){
	    super.add((DCardComponent) cardVector.get(j));
	}
	this.repaint();
    }



    public void rearrange(){
        // we need to find maximum width required and height required.
        Dimension d;
        int maxwidth = 0;
        DEPTH = 30;
        for (int i = 0;i < cardVector.size(); i++){
            ((AbstractComponent) cardVector.get(i)).rearrange();
            d = ((AbstractComponent) cardVector.get(i)).getSize();

	    if ((new Double(d.getWidth())).intValue() > maxwidth) maxwidth = (new Double(d.getWidth())).intValue();
            //((AbstractComponent) cardVector.get(i)).setLocation(new Point((this.getWidth() - (new Double(d.getWidth())).intValue())/2, DEPTH));
            DEPTH = DEPTH + 10; //+ (new Double(d.getHeight())).intValue();
            if (this.getHeight() < DEPTH) {
                super.setSize(new Dimension(this.getWidth(),DEPTH + 10));
            }

        }

	/*if (DEPTH + 20 < this.getHeight() && DEPTH > 665) {
	    super.setSize(new Dimension(this.getWidth(),DEPTH + 10));
	} else if (DEPTH < 665) {
	    super.setSize(new Dimension(this.getWidth(), 665));
	    }
	if (maxwidth >= this.getWidth()){
	    super.setSize(10 + maxwidth,this.getHeight());
	    } else if(maxwidth < 400) super.setSize(400,this.getHeight()); */

        //System.out.println("rearranging folder:" + folderName.getText());

    }



    public void paintComponent(Graphics g){
        int h = getHeight();
        int w = getWidth();
        int[] bxpoints = {70,70,w,w};
        int[] bypoints = {0,25,25,0};
        super.paintComponent(g);
        g.setColor(java.awt.SystemColor.white);
        g.fillPolygon(bxpoints,bypoints,4);


    }


    public void setLocation(Point p){
	super.setLocation(p);
    }

    public void setSize(Dimension d){
	super.setSize(d);
    }

    public Dimension getSize() {
	return super.getSize();
    }

    public void setName(String n){
	folderName.setText(n);
    }

    public String getName(){
	return folderName.getText();
    }

    public void toggleSelect(){
	if (selected){
	    selected = false;
            //super.setBackground(new java.awt.Color(255, 100, 0));
	    super.setBorder(BorderFactory.createLineBorder(java.awt.Color.white));
            repaint();
	} else {
	    selected = true;
            //super.setBackground(new java.awt.Color(255,100,100));
	    super.setBorder(BorderFactory.createLineBorder(java.awt.Color.red));
            repaint();
	}
    }

    public String genQuery() {
	String name, subquery;
	//name = folderName.getText();
	subquery = this.getSubQueries();
	return("<xml>\n " + subquery + "\n</xml>");
    }

    public String getSubQueries(){
	String subQ = "";
	int i = 0;
	for(i=0;i< cardVector.size() - 1; i++){
	    System.out.println("bla");
	    subQ += ((AbstractComponent) cardVector.get(i)).genQuery() + "\n";
	}
	subQ += ((AbstractComponent) cardVector.get(i)).genQuery();
	
	return subQ;
    }

    // updateClick makes sure this Object does not get deleted unless specifically selected
    public void updateClick(){
        selected = false;
    }

    //public void mouseEntered(MouseEvent e){ }
    //public void mouseExited(MouseEvent e){ }
    //public void mousePressed(MouseEvent e){ }
    //public void mouseReleased(MouseEvent e){ }


    public void folderComponentMouseClicked(MouseEvent e){
	System.out.println("Folder clicked: " + folderName.getText());
	if (selected){
	    selected = false;
            //super.setBackground(new java.awt.Color(255, 100, 0));
	    super.setBorder(BorderFactory.createLineBorder(java.awt.Color.white));
            repaint();
	} else {
	    selected = true;
            //super.setBackground(new java.awt.Color(255,100,100));
	    super.setBorder(BorderFactory.createLineBorder(java.awt.Color.red));
            repaint();
	}
    }

    //public void moved(AbstractComponent a) {}

    public boolean isSelected(){
	return selected;
    }

    public void erase(){
	for(int i = 0 ; i < cardVector.size(); i++){
	    if (((AbstractComponent) cardVector.get(i)).isSelected()){
		super.remove((DCardComponent)cardVector.get(i));
		cardVector.removeElementAt(i);
	    } else {
		((AbstractComponent) cardVector.get(i)).erase();
	    }
	}
	//this.rearrange();
    }
}
	
