/** 
 * DisplayFrame.java
 *
 * Title: The FoXQ Interface
 * Description:	This is the modified interface for FoXQ.
 * @author Robin Abraham
 * @version 1.0			
 */


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Vector;

public class DisplayFrame extends javax.swing.JFrame {

        // mode decides what action is possible next.
        String mode = "";
        String url = "\"http://www.engr.orst.edu/~abraharo/bib.xml\"";
        // component stores the current basic query component -> rule or folder
        DFolderComponent component;

	// member declarations
	javax.swing.JPanel optionsPanel = new javax.swing.JPanel();

	javax.swing.JButton helpButton = new javax.swing.JButton();
	javax.swing.JButton eraseButton = new javax.swing.JButton();
	javax.swing.JButton matrixButton = new javax.swing.JButton();
	javax.swing.JButton diagButton = new javax.swing.JButton();

	javax.swing.JButton openButton = new javax.swing.JButton();
	javax.swing.JButton saveButton = new javax.swing.JButton();

	javax.swing.JScrollPane DTDViewerPane = new javax.swing.JScrollPane();
	javax.swing.JPanel DTDViewer = new javax.swing.JPanel();
	javax.swing.JPanel extrasPanel = new javax.swing.JPanel();
	javax.swing.JScrollPane queryScrollPane = new javax.swing.JScrollPane();
	javax.swing.JPanel queryPanel = new javax.swing.JPanel();

	public DisplayFrame() {

	}

	public void initComponents() throws Exception {
		// the following code picks the button icons
		java.awt.Image img0 = getToolkit().getImage(ClassLoader.getSystemResource("images/helpNormal.gif"));
		java.awt.Image img1 = getToolkit().getImage(ClassLoader.getSystemResource("images/helpClicked.gif"));
		java.awt.Image img2 = getToolkit().getImage(ClassLoader.getSystemResource("images/eraseNormal.gif"));
		java.awt.Image img3 = getToolkit().getImage(ClassLoader.getSystemResource("images/eraseClicked.gif"));
		java.awt.Image img4 = getToolkit().getImage(ClassLoader.getSystemResource("images/matrixNormal.gif"));
		java.awt.Image img5 = getToolkit().getImage(ClassLoader.getSystemResource("images/matrixClicked.gif"));
		java.awt.Image img6 = getToolkit().getImage(ClassLoader.getSystemResource("images/diagNormal.gif"));
		java.awt.Image img7 = getToolkit().getImage(ClassLoader.getSystemResource("images/diagClicked.gif"));
		java.awt.Image img8 = getToolkit().getImage(ClassLoader.getSystemResource("images/openNormal.gif"));
		java.awt.Image img9 = getToolkit().getImage(ClassLoader.getSystemResource("images/openClicked.gif"));
		java.awt.Image img10 = getToolkit().getImage(ClassLoader.getSystemResource("images/saveNormal.gif"));
		java.awt.Image img11 = getToolkit().getImage(ClassLoader.getSystemResource("images/saveClicked.gif"));

		// Setup for the options panel (one on WEST)
		optionsPanel.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.DEFAULT_CURSOR));
		optionsPanel.setSize(new java.awt.Dimension(100, 800));
		optionsPanel.setBorder(new javax.swing.border.SoftBevelBorder(0));
		optionsPanel.setLocation(new java.awt.Point(0, 0));
		optionsPanel.setVisible(true);
		optionsPanel.setLayout(null);
		optionsPanel.setToolTipText("Move your mouse over any item for descriptions.");
		optionsPanel.setBackground(new java.awt.Color(255, 153, 0));

		// Setup for buttons (on WEST)
		helpButton.setIcon(new javax.swing.ImageIcon(img0));
		helpButton.setPressedIcon(new javax.swing.ImageIcon(img1));
		helpButton.setToolTipText("Click for help");
		helpButton.setBorder(new javax.swing.plaf.BorderUIResource.EmptyBorderUIResource(new java.awt.Insets(0, 0, 0, 0)));
		helpButton.setVisible(true);
		helpButton.setSize(new java.awt.Dimension(70, 70));
		helpButton.setSelectedIcon(new javax.swing.ImageIcon(img1));
		helpButton.setBackground(new java.awt.Color(255, 153, 0));
		helpButton.setContentAreaFilled(false);
		helpButton.setLocation(new java.awt.Point(10, 30));

		eraseButton.setIcon(new javax.swing.ImageIcon(img2));
		eraseButton.setPressedIcon(new javax.swing.ImageIcon(img3));
		eraseButton.setToolTipText("Select elements and click to erase");
		eraseButton.setBorder(new javax.swing.plaf.BorderUIResource.EmptyBorderUIResource(new java.awt.Insets(0, 0, 0, 0)));
		eraseButton.setVisible(true);
		eraseButton.setSize(new java.awt.Dimension(70, 80));
		eraseButton.setSelectedIcon(new javax.swing.ImageIcon(img3));
		eraseButton.setBackground(new java.awt.Color(255, 153, 0));
		eraseButton.setContentAreaFilled(false);
		eraseButton.setLocation(new java.awt.Point(10, 120));

		matrixButton.setIcon(new javax.swing.ImageIcon(img4));
		matrixButton.setPressedIcon(new javax.swing.ImageIcon(img5));
		matrixButton.setToolTipText("Click to rearrange elements in box format");
		matrixButton.setBorder(new javax.swing.plaf.BorderUIResource.EmptyBorderUIResource(new java.awt.Insets(0, 0, 0, 0)));
		matrixButton.setVisible(true);
		matrixButton.setSize(new java.awt.Dimension(70, 70));
		matrixButton.setSelectedIcon(new javax.swing.ImageIcon(img5));
		matrixButton.setBackground(new java.awt.Color(255, 153, 0));
		matrixButton.setContentAreaFilled(false);
		matrixButton.setLocation(new java.awt.Point(10, 210));

		diagButton.setIcon(new javax.swing.ImageIcon(img6));
		diagButton.setPressedIcon(new javax.swing.ImageIcon(img7));
		diagButton.setToolTipText("Click to arrange elements diagonally");
		diagButton.setBorder(new javax.swing.plaf.BorderUIResource.EmptyBorderUIResource(new java.awt.Insets(0, 0, 0, 0)));
		diagButton.setVisible(true);
		diagButton.setSize(new java.awt.Dimension(70, 70));
		diagButton.setSelectedIcon(new javax.swing.ImageIcon(img6));
		diagButton.setBackground(new java.awt.Color(255, 153, 0));
		diagButton.setContentAreaFilled(false);
		diagButton.setLocation(new java.awt.Point(10, 290));

		openButton.setIcon(new javax.swing.ImageIcon(img8));
		openButton.setPressedIcon(new javax.swing.ImageIcon(img9));
		openButton.setToolTipText("Click to open saved file");
		openButton.setBorder(new javax.swing.plaf.BorderUIResource.EmptyBorderUIResource(new java.awt.Insets(0, 0, 0, 0)));
		openButton.setVisible(true);
		openButton.setSize(new java.awt.Dimension(70, 70));
		openButton.setSelectedIcon(new javax.swing.ImageIcon(img9));
		openButton.setBackground(new java.awt.Color(255, 153, 0));
		openButton.setContentAreaFilled(false);
		openButton.setLocation(new java.awt.Point(10, 10));

		saveButton.setIcon(new javax.swing.ImageIcon(img10));
		saveButton.setPressedIcon(new javax.swing.ImageIcon(img11));
		saveButton.setToolTipText("Click to save to file");
		saveButton.setBorder(new javax.swing.plaf.BorderUIResource.EmptyBorderUIResource(new java.awt.Insets(0, 0, 0, 0)));
		saveButton.setVisible(true);
		saveButton.setSize(new java.awt.Dimension(70, 70));
		saveButton.setSelectedIcon(new javax.swing.ImageIcon(img11));
		saveButton.setBackground(new java.awt.Color(255, 153, 0));
		saveButton.setContentAreaFilled(false);
		saveButton.setLocation(new java.awt.Point(90, 10));

		/* // Setup for the DTD viewer (on EAST)
		DTDViewerPane.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.DEFAULT_CURSOR));
		DTDViewerPane.setSize(new java.awt.Dimension(150, 800));
		DTDViewerPane.setLocation(new java.awt.Point(840, 0));
		DTDViewerPane.setDoubleBuffered(true);
		DTDViewerPane.setVisible(true);
		DTDViewerPane.setBackground(java.awt.Color.orange);
		DTDViewer.setBorder(new javax.swing.border.SoftBevelBorder(0));
		DTDViewer.setVisible(true);
		DTDViewer.setLayout(null);
		DTDViewer.setBackground(new java.awt.Color(255, 153, 0));
		*/

		// Setup for the extra-options panel (on SOUTH)
		extrasPanel.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.DEFAULT_CURSOR));
		extrasPanel.setSize(new java.awt.Dimension(890, 100));
		extrasPanel.setBorder(new javax.swing.border.SoftBevelBorder(0));
		extrasPanel.setLocation(new java.awt.Point(100, 670));
		extrasPanel.setVisible(true);
		extrasPanel.setLayout(null);
		extrasPanel.setToolTipText("Extra menu options");
		extrasPanel.setBackground(new java.awt.Color(255, 153, 0));

		// Setup for query panel (on NORTH)
		queryScrollPane.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.DEFAULT_CURSOR));
		queryScrollPane.setSize(new java.awt.Dimension(890, 670));
		queryScrollPane.setLocation(new java.awt.Point(100, 0));
		queryScrollPane.setVisible(true);
		queryScrollPane.setToolTipText("FoXQ query builder area");
		queryScrollPane.setBackground(new java.awt.Color(255, 153, 0));
		queryScrollPane.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
		queryScrollPane.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		queryPanel.setVisible(true);
		queryPanel.setLayout(null);
		queryPanel.setToolTipText("FoXQ query builder area");
		//queryPanel.setBackground(java.awt.Color.orange);
		queryPanel.setBackground(java.awt.Color.white);
		setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.CROSSHAIR_CURSOR));
		setLocation(new java.awt.Point(0, 0));
		getContentPane().setLayout(null);
		setTitle("Result-Viewer Interface");
		setResizable(false);
		getContentPane().setBackground(new java.awt.Color(255, 153, 0));

		optionsPanel.add(helpButton);
		optionsPanel.add(eraseButton);
		optionsPanel.add(matrixButton);
		optionsPanel.add(diagButton);

		extrasPanel.add(openButton);
		extrasPanel.add(saveButton);

		DTDViewerPane.getViewport().add(DTDViewer);
		queryScrollPane.getViewport().add(queryPanel);
		getContentPane().add(optionsPanel);
		getContentPane().add(DTDViewerPane);
		getContentPane().add(extrasPanel);
		getContentPane().add(queryScrollPane);

		setSize(new java.awt.Dimension(1000, 800));

		// event handling for the options buttons
		helpButton.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent e) {
				helpButtonMouseClicked(e);
			}
		});

		eraseButton.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent e) {
				eraseButtonMouseClicked(e);
			}
		});

		matrixButton.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent e) {
				matrixButtonMouseClicked(e);
			}
		});

		diagButton.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent e) {
				diagButtonMouseClicked(e);
			}
		});

		openButton.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent e) {
				openButtonMouseClicked(e);
			}
		});

		saveButton.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent e) {
				saveButtonMouseClicked(e);
			}
		});

		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				thisWindowClosing(e);
			}
		});

	}
  
  	private boolean mShown = false;
  	
	public void addNotify() {
	    super.addNotify();
		
	    if (mShown)
		return;
			
	    // resize frame to account for menubar
	    JMenuBar jMenuBar = getJMenuBar();
	    if (jMenuBar != null) {
		int jMenuBarHeight = jMenuBar.getPreferredSize().height;
		Dimension dimension = getSize();
		dimension.height += jMenuBarHeight;
		setSize(dimension);
		
		// move down components in layered pane
		Component[] components = getLayeredPane().getComponentsInLayer(JLayeredPane.DEFAULT_LAYER.intValue());
		for (int i = 0; i < components.length; i++) {
		    Point location = components[i].getLocation();
		    location.move(location.x, location.y + jMenuBarHeight);
		    components[i].setLocation(location);
		}
	    }
	    
	    mShown = true;
	}

        // Button actions
	public void helpButtonMouseClicked(java.awt.event.MouseEvent e) {
	    // mode doesn't matter.
	    try {
		ErrorDialog err = new ErrorDialog("Help not implemented in this version!");
		err.initComponents();
		err.setVisible(true);
	    }
	    catch (Exception ex) {
		ex.printStackTrace();
	    }
	}		

	public void eraseButtonMouseClicked(java.awt.event.MouseEvent e) {
	    if (component != null){
		if (component.isSelected()){
		    component = null;
		    queryPanel.removeAll();
		    queryPanel.revalidate();
		    repaint();
		    System.gc();
		} else {
		    component.erase();
		    component.rearrange();
		    queryPanel.revalidate();
		    repaint();
		    System.gc();
		}
	    } else {
		try {
		    ErrorDialog err = new ErrorDialog("Screen empty - nothing to erase!");
		    err.initComponents();
		    err.setVisible(true);
		    mode = "";
		}
		catch (Exception ex) {
		    ex.printStackTrace();
		}		
	    }
      	}		

	public void matrixButtonMouseClicked(java.awt.event.MouseEvent e) {
	    try {
		ErrorDialog err = new ErrorDialog("This feature not implemented in current version!");
		err.initComponents();
		err.setVisible(true);
	    }
	    catch (Exception ex) {
		ex.printStackTrace();
	    }
       	}		

	public void diagButtonMouseClicked(java.awt.event.MouseEvent e) {
	    try {
		ErrorDialog err = new ErrorDialog("This feature not implemented in current version!");
		err.initComponents();
		err.setVisible(true);
	    }
	    catch (Exception ex) {
		ex.printStackTrace();
	    }
       	}		

	public void openButtonMouseClicked(java.awt.event.MouseEvent e) {
	    try {
		ErrorDialog err = new ErrorDialog("File options not implemented in this version!");
		err.initComponents();
		err.setVisible(true);
	    }
	    catch (Exception ex) {
		ex.printStackTrace();
	    }
       	}
		
	public void saveButtonMouseClicked(java.awt.event.MouseEvent e) {
	    String data = component.genQuery();
	    try {
		ErrorDialog err = new ErrorDialog("File options not implemented in this version!");
		err.initComponents();
		err.setVisible(true);
	    }
	    catch (Exception ex) {
		ex.printStackTrace();
	    }	    
       	}

        public void clearScreen(){
	    queryPanel.removeAll();
	}

        public void displayXML(DFolderComponent comp) {
	    component = comp;
	    queryPanel.removeAll();
	    queryPanel.add((Component) component);
            if (((JComponent) component).getHeight() > queryPanel.getHeight()){
                queryPanel.setSize(new java.awt.Dimension(queryPanel.getWidth(),((JComponent) component).getHeight()));
                queryPanel.setPreferredSize(new java.awt.Dimension(queryPanel.getWidth(),((JComponent) component).getHeight()));
            } else {
		queryPanel.setPreferredSize(new java.awt.Dimension(queryPanel.getWidth(),668));
	    }
	    queryPanel.revalidate();
	    repaint();	    
	}

	// Close the window when the close box is clicked
	void thisWindowClosing(java.awt.event.WindowEvent e) {
		setVisible(false);
		dispose();
		//System.exit(0);
	}
	
}
